#import "libSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

extern int WindowSizeForSSAEp      = 300;
extern int SSALag                  = 25;
extern int SSAPrice                = PRICE_CLOSE;
extern int SSANumberOfComputations = 2;
extern int CalculateEndPointForBar = 0;

//
//
//
//
//

double prices[];   
double ssaSourceValues[];
double ssaResult[];

int init()   { return(0); }
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   if (ArraySize(prices)!=WindowSizeForSSAEp+1)
   {
      ArrayResize(prices,WindowSizeForSSAEp+1);
      ArrayResize(ssaSourceValues,WindowSizeForSSAEp);
      ArrayResize(ssaResult,WindowSizeForSSAEp);
   }
   for (int i=0; i<=WindowSizeForSSAEp; i++) prices[i] = iMA(NULL,0,1,0,MODE_SMA,SSAPrice,i+CalculateEndPointForBar);

   //
   //
   //
   //
   //
   
   ArrayCopy(ssaSourceValues,prices,0,1,WindowSizeForSSAEp); 
         fastSingular(ssaSourceValues,WindowSizeForSSAEp,SSALag,SSANumberOfComputations,ssaResult);
         double previousSSA = ssaResult[0];
   ArrayCopy(ssaSourceValues,prices,0,0,WindowSizeForSSAEp);
         fastSingular(ssaSourceValues,WindowSizeForSSAEp,SSALag,SSANumberOfComputations,ssaResult);
         double currentSSA = ssaResult[0];
      
         //
         //
         //
         //
         //
         
         string add = "faling"; if (currentSSA>previousSSA) add = "rising";
         Comment("SSA EP value at bar "+ CalculateEndPointForBar   +" : "+DoubleToStr(currentSSA,Digits)+"\n"+
                 "SSA EP value at bar "+(CalculateEndPointForBar+1)+" : "+DoubleToStr(previousSSA,Digits)+"\n"+ 
                 "slope is : "+DoubleToStr(currentSSA-previousSSA,Digits)+" the slope is "+add);
   return(0);
}